'HotHook.inc copyright 2005 James J Keene
'Updated: June 23, 2005

'1. use HookOpen with main form handle and hook type
'2. put HookMsg code on main form .OnMessage routine
'3. call HookClose in main form .OnClose routine
'   or before program END

'WH_type used as SUB HookOpen argument:
'Each hook type has a Proc defining contents of wParam and lParam.
'Uncomment what you actually use:

'$DEFINE WH_MSGFILTER -1

'$DEFINE WH_JOURNALRECORD 0
'TYPE EVENTMSG
'  message As DWORD 
'  paramL As DWORD 
'  paramH As DWORD 
'  time As DWORD 
'  hwnd As DWORD 
'END EVENTMSG

'$DEFINE WH_JOURNALPLAYBACK 1
'uses EVENTMSG

'$DEFINE WH_KEYBOARD 2
'wParam and lParam same as in .OnKeyDown

'$DEFINE WH_GETMESSAGE 3
'TYPE MSG
'  hwnd As DWORD
'  message As DWORD
'  wParam As DWORD
'  lParam As DWORD
'  time As DWORD
'  x As INTEGER
'  y As INTEGER
'END MSG

'$DEFINE WH_CALLWNDPROC 4
'TYPE CWPSTRUCT
'  lParam As DWORD
'  wParam As DWORD
'  message As DWORD
'  hwnd As DWORD
'END CWPSTRUCT

'$DEFINE WH_CBT 5

'$DEFINE WH_SYSMSGFILTER 6
'uses MSG

'$DEFINE WH_MOUSE 7
'TYPE MOUSEHOOKSTRUCT
'  x As LONG  'point.x
'  y As LONG  'point.y
'  hwnd As DWORD
'  wHitTestCode As DWORD
'  dwExtraInfo As DWORD
'END MOUSEHOOKSTRUCT

'$DEFINE WH_HARDWARE 8

'$DEFINE WH_DEBUG 9
'TYPE DEBUGHOOKINFO
'  hModuleHook As DWORD
'  Reserved As DWORD
'  lParam As DWORD
'  wParam As DWORD
'  code As DWORD
'DEBUGHOOKINFO ENDS

'$DEFINE WH_SHELL 10

'$DEFINE WH_FOREGROUNDIDLE 11

'Here we put the .dll as a $RESOURCE to be sure we have it.
'Be sure a copy of HotHook.dll is in your $RESOURCE path.

$RESOURCE Hot_Hook as "HotHook.dll"
IF NOT FILEEXISTS("HotHook.dll") THEN EXTRACTRESOURCE "Hot_Hook","HotHook.dll"

Declare SUB HookOpen LIB "HotHook" (fHnd As DWORD, idHook As DWORD)
Declare SUB HookClose LIB "HotHook"
